#include <windows.h>
#include <mmsystem.h>
#pragma hdrstop

#include "mixerctr.h"
//---------------------------------------------------------------------------

//***********
// {[
//***********
bool TMixerCtr::initMasterVolumeControl(void)
{
	MIXERLINE mxl ;
	MIXERCONTROL mxc ;
	MIXERLINECONTROLS mxlc ;

	if ( m_dwVolumeControlID != 0xffffffff ) return true ;
	if ( init( NULL ) == false ) return false ;

	mxl.cbStruct = sizeof(MIXERLINE) ;
	mxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
	if ( ::mixerGetLineInfo( (HMIXEROBJ)m_hMixer,&mxl,
				MIXER_OBJECTF_HMIXER | MIXER_GETLINEINFOF_COMPONENTTYPE)!=MMSYSERR_NOERROR
       )
    {
        return false ;
    }

	mxlc.cbStruct = sizeof(MIXERLINECONTROLS) ;
	mxlc.dwLineID = mxl.dwLineID ;
	mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_VOLUME ;
	mxlc.cControls = 1 ;
	mxlc.cbmxctrl = sizeof(MIXERCONTROL) ;
	mxlc.pamxctrl = &mxc ;
	if ( ::mixerGetLineControls( (HMIXEROBJ)m_hMixer,&mxlc,
			   MIXER_OBJECTF_HMIXER | MIXER_GETLINECONTROLSF_ONEBYTYPE) != MMSYSERR_NOERROR
       )
    {
        return false ;
    }

	m_dwMinimum = mxc.Bounds.dwMinimum ;
	m_dwMaximum = mxc.Bounds.dwMaximum ;
	m_dwVolumeControlID = mxc.dwControlID ;

	return true ;
}
//---------------------------------------------------------------------------
bool TMixerCtr::getVolume(int *Val)
{
	MIXERCONTROLDETAILS_UNSIGNED mxcdVolume ;
	MIXERCONTROLDETAILS mxcd ;

	if ( initMasterVolumeControl() == false ) return false ;

	mxcd.cbStruct = sizeof(MIXERCONTROLDETAILS) ;
	mxcd.dwControlID = m_dwVolumeControlID ;
	mxcd.cChannels = 1 ;
	mxcd.cMultipleItems = 0 ;
	mxcd.cbDetails = sizeof(MIXERCONTROLDETAILS_UNSIGNED) ;
	mxcd.paDetails = &mxcdVolume ;
	if ( ::mixerGetControlDetails( (HMIXEROBJ)m_hMixer,&mxcd,
				 MIXER_OBJECTF_HMIXER | MIXER_GETCONTROLDETAILSF_VALUE)!=MMSYSERR_NOERROR
       )
    {
        return false ;
    }

	*Val = ((mxcdVolume.dwValue - m_dwMinimum)*100 + (m_dwMaximum - m_dwMinimum)/2) / (m_dwMaximum - m_dwMinimum) ;

	return true ;
}
//---------------------------------------------------------------------------
bool TMixerCtr::setVolume(int Val)
{
	MIXERCONTROLDETAILS_UNSIGNED	mxcdVolume ;
	MIXERCONTROLDETAILS				mxcd ;

	if ( initMasterVolumeControl() == false ) return false ;

	mxcdVolume.dwValue = Val * (m_dwMaximum - m_dwMinimum)/100 + m_dwMinimum ;

	mxcd.cbStruct = sizeof(MIXERCONTROLDETAILS) ;
	mxcd.dwControlID = m_dwVolumeControlID ;
	mxcd.cChannels = 1 ;
	mxcd.cMultipleItems = 0 ;
	mxcd.cbDetails = sizeof(MIXERCONTROLDETAILS_UNSIGNED) ;
	mxcd.paDetails = &mxcdVolume ;
	if ( ::mixerSetControlDetails( (HMIXEROBJ)m_hMixer,&mxcd,
				 MIXER_OBJECTF_HMIXER | MIXER_SETCONTROLDETAILSF_VALUE)!=MMSYSERR_NOERROR
       )
    {
		return false ;
    }
    
	return true ;
}
//---------------------------------------------------------------------------

//*********
// ~[g
//*********
bool TMixerCtr::initMasterMuteControl()
{
	MIXERLINE mxl ;
	MIXERCONTROL mxc ;
	MIXERLINECONTROLS mxlc ;

	if ( m_dwMuteControlID != 0xffffffff ) return true ;
	if ( init( NULL ) == false ) return false ;

	mxl.cbStruct = sizeof(MIXERLINE) ;
	mxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
	if ( ::mixerGetLineInfo( (HMIXEROBJ)m_hMixer,&mxl,
				MIXER_OBJECTF_HMIXER | MIXER_GETLINEINFOF_COMPONENTTYPE)!=MMSYSERR_NOERROR
       )
    {
        return false ;
    }

	mxlc.cbStruct = sizeof(MIXERLINECONTROLS) ;
	mxlc.dwLineID = mxl.dwLineID ;
	mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_MUTE ;
	mxlc.cControls = 1 ;
	mxlc.cbmxctrl = sizeof(MIXERCONTROL) ;
	mxlc.pamxctrl = &mxc ;
	if ( ::mixerGetLineControls( (HMIXEROBJ)m_hMixer,&mxlc,
			   MIXER_OBJECTF_HMIXER | MIXER_GETLINECONTROLSF_ONEBYTYPE) != MMSYSERR_NOERROR
       )
    {
        return false ;
    }

	m_dwMuteControlID = mxc.dwControlID ;

	return true ;
}
//---------------------------------------------------------------------------
bool TMixerCtr::getMuteState(bool *Val)
{
	MIXERCONTROLDETAILS_BOOLEAN mxcdMute ;
	MIXERCONTROLDETAILS mxcd ;

	if ( initMasterMuteControl() == false ) return false ;

	mxcd.cbStruct = sizeof(MIXERCONTROLDETAILS) ;
	mxcd.dwControlID = m_dwMuteControlID ;
	mxcd.cChannels = 1 ;
	mxcd.cMultipleItems = 0 ;
	mxcd.cbDetails = sizeof(MIXERCONTROLDETAILS_BOOLEAN) ;
	mxcd.paDetails = &mxcdMute ;
	if ( ::mixerGetControlDetails( (HMIXEROBJ)m_hMixer,&mxcd,
				 MIXER_OBJECTF_HMIXER | MIXER_GETCONTROLDETAILSF_VALUE)!=MMSYSERR_NOERROR
       )
    {
        return false ;
    }

	*Val = mxcdMute.fValue ;

	return true ;
}
//---------------------------------------------------------------------------
bool TMixerCtr::setMuteState(bool Val)
{
	MIXERCONTROLDETAILS_BOOLEAN mxcdMute ;
	MIXERCONTROLDETAILS mxcd ;

	if ( initMasterMuteControl() == false ) return false ;

	mxcdMute.fValue = Val ;

	mxcd.cbStruct = sizeof(MIXERCONTROLDETAILS) ;
	mxcd.dwControlID = m_dwMuteControlID ;
	mxcd.cChannels = 1 ;
	mxcd.cMultipleItems = 0 ;
	mxcd.cbDetails = sizeof(MIXERCONTROLDETAILS_BOOLEAN) ;
	mxcd.paDetails = &mxcdMute ;
	if ( ::mixerSetControlDetails( (HMIXEROBJ)m_hMixer,&mxcd,
				 MIXER_OBJECTF_HMIXER | MIXER_SETCONTROLDETAILSF_VALUE)!=MMSYSERR_NOERROR
       )
    {
        return false ;
    }

	return true ;
}
//---------------------------------------------------------------------------

